---
title: ReadableStream
slug: Web/API/ReadableStream
tags:
  - API
  - Fetch
  - Fetch API
  - Files
  - HTTP
  - Interface
  - Networking
  - ReadableStream
  - Reference
  - Streams
  - data
---
<p>{{APIRef("Streams")}}</p>

<p><span class="seoSummary">The <code>ReadableStream</code> interface of the <a href="/en-US/docs/Web/API/Streams_API">Streams API</a> represents a readable stream of byte data. The <a href="/en-US/docs/Web/API/Fetch_API">Fetch API</a> offers a concrete instance of a <code>ReadableStream</code> through the {{domxref("Body.body", "body")}} property of a {{domxref("Response")}} object.</span></p>

<h2 id="Constructor">Constructor</h2>

<dl>
	<dt>{{domxref("ReadableStream.ReadableStream", "ReadableStream()")}}</dt>
	<dd>Creates and returns a readable stream object from the given handlers.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<dl>
	<dt>{{domxref("ReadableStream.locked")}} {{readonlyInline}}</dt>
	<dd>The <code>locked</code> getter returns whether or not the readable stream is <a href="https://streams.spec.whatwg.org/#locked-to-a-reader" id="ref-for-locked-to-a-reader②">locked to a reader</a>.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
	<dt>{{domxref("ReadableStream.cancel()")}}</dt>
	<dd>Cancels the stream, signaling a loss of interest in the stream by a consumer. The supplied reason argument will be given to the underlying source, which may or may not use it.</dd>
</dl>

<dl>
	<dt>{{domxref("ReadableStream.getIterator()")}}</dt>
	<dd>Creates a ReadableStream async iterator instance and locks the stream to it. While the stream is locked, no other reader can be acquired until this one is released.</dd>
</dl>

<dl>
	<dt>{{domxref("ReadableStream.getReader()")}}</dt>
	<dd>Creates a reader and locks the stream to it. While the stream is locked, no other reader can be acquired until this one is released.</dd>
	<dt>{{domxref("ReadableStream.pipeThrough()")}}</dt>
	<dd>Provides a chainable way of piping the current stream through a transform stream or any other writable/readable pair.</dd>
	<dt>{{domxref("ReadableStream.pipeTo()")}}</dt>
	<dd>Pipes the current ReadableStream to a given {{domxref("WritableStream")}} and returns a promise that fulfills when the piping process completes successfully, or rejects if any errors were encountered.</dd>
	<dt>{{domxref("ReadableStream.tee()")}}</dt>
	<dd>The <code>tee</code> method <a href="https://streams.spec.whatwg.org/#tee-a-readable-stream" id="ref-for-tee-a-readable-stream②">tees</a> this readable stream, returning a two-element array containing the two resulting branches as new {{domxref("ReadableStream")}} instances. Each of those streams receives the same incoming data.</dd>
	<dt>{{domxref("ReadableStream[@@asyncIterator]()")}}</dt>
	<dd>Alias of <code>getIterator</code> method.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>In the following example, an artificial {{domxref("Response")}} is created to stream HTML fragments fetched from another resource to the browser.</p>

<p>It demonstrates the usage of a {{domxref("ReadableStream")}} in combination with a {{domxref("Uint8Array")}}.</p>

<pre class="brush: js">fetch("https://www.example.org/").then((response) =&gt; {
  const reader = response.body.getReader();
  const stream = new ReadableStream({
    start(controller) {
      // The following function handles each data chunk
      function push() {
        // "done" is a Boolean and value a "Uint8Array"
        reader.read().then(({ done, value }) =&gt; {
          // Is there no more data to read?
          if (done) {
            // Tell the browser that we have finished sending data
            controller.close();
            return;
          }

          // Get the data and send it to the browser via the controller
          controller.enqueue(value);
          push();
        });
      };

      push();
    }
  });

  return new Response(stream, { headers: { "Content-Type": "text/html" } });
});
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('Streams','#rs-class','ReadableStream')}}</td>
			<td>{{Spec2('Streams')}}</td>
			<td>Initial definition</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.ReadableStream")}}</p>
</div>

<h2 id="See_Also">See Also</h2>

<ul>
	<li><a href="https://whatwg-stream-visualizer.glitch.me/">WHATWG Stream Visualiser</a>, for a basic visualisation of readable, writable, and transform streams.</li>
</ul>
